                     Computer Science 825
                           Quiz 1           Name _______________________


Terminology:  the very highest layer is the APPLICATION LAYER = Layer N
              the very lowest  layer is the PHYSICAL LAYER    = Layer 1

1. a. In the ISO/OSI model at which of the seven layers is global
      interoperability required.




   b. Which is the lowest layer that is present in hosts, but is not
      present in routers




2. Protocol headers used by a layer N are handled by layer K (K < N)
   as follows:

   a. The are removed before        b. They are treated as user data.
      the packet arrives at
      Layer K

   c. They are deleted by layer K.

3. Two things that a protocol can do to earn the term "unreliable"
   are (1) deliver packets with bits that have been inverted and
   (2) deliver packets out of order.  Identify two others:

   a.


   b.

4. Suppose a PCM scheme supports a bit rate of  80,000 bps and
   quantizes the signal into 256 distinct levels.  What is the
   highest frequency that it can carry?







5. What bandwidth is required to support a bit rate of 100,000 BPS
   on a channel with a 40dB SNR?







6. How many distinct signalling states must be used to send 40,000
   bits/sec over channel with a bandwidth of 4,000 HZ. (Hint: fractional
   #'s of signalling states don't work well!)






Recall the Bell 212A modem discussed in class.  It signalled using
phase modulation with 4 phase angles, 45, 135, 225, and 315 degrees.

7. When a long burst of 00000000000000000000 is transmitted,

   a. The modem will emit a             b. There will be a +45 degree
      pure sine wave of the form           phase shift in the signal
      f(t) = sin(wt + 45dg)                every bit time.
      for the duration of the burst

   c. There will be a +45 degree
      phase shift every other bit
      time.



8. For a signaling scheme to be properly classified as self-clocking
   it must:

   a. use phase modulation               b. change state every bit time

   c. change state every baud time       d. modulate at least two of
                                            amplitude, frequency, and phase.


9. Suppose a PCM transmission system has a bit rate of 2^20 bps
   and can carry frequencies between 0 and 2^12 Hz.  Into how
   many discrete levels can the input signal be quantized by the
   A-D converter.












10. The main reason digital channels have much lower error rates than analog
    when used over long distances is:

    a. Digital signalling is baseband   c. Digital signals are amplified
       instead of analog.                  rather than regenerated.

    b. Digital signals are regenerated  d. Digital channels have much higher
       rather than amplified.              SNR's than analog.


11. Do protocols (as the term is normally used in networking, e.g
    in SDLC, TCP, or IP) define the rules under which a layer communicates

    a. With the layer above it   b. With a peer layer in another node.

    c. With the layer below it.  d. All of the above.


                      Computer Science 825
                         Quiz 2              Name _______________________

1. The use of very small slot sizes in a TDM multiplexing scheme is:

   a. Inefficient and shouldn't       b. Generally shouldn't be used for
      be used in either STDM or ATDM     SDTM but is OK for ATDM

   c. Generally shouldn't be used     d. Perfectly OK for both
      for ATDM but is OK for STDM

2. For a slotted aloha system for each value of "S" (except the S
   corresponding to G = 1.0) there are two different values of
   G which will result in the throughput being "S". For a given "S"
   the average delay before a packet is successfully transmitted
   is:

   a. The same for both "G"s          b. Larger for the small "G"
                                         than for the big "G".

   c. Larger for the big "G"          d. Totally independent of
      than for the small "G".            the "G" value.

3. If packets are generated at random (exponentially distributed) by
   each station on a shared channel, then statically assigning 1/Nth of
   the bandwidth to each station (rather than having a single waiting
   queue)

   a. Will have no appreciable effect      b. Will cause the delay to increase
      on the queueing delay.                  by a factor of N

   c. Will cause the delay to be reduced   d. Will cause the delay to increase
      by a factor of N                         by N seconds.

4. Suppose a network has links that carry data at a rate of 10,000
   bits per second.  Suppose Node A and Node B are connected by a
   path that requires 6 hops (transmissions).

   a. What is the minimum time required to send a 400,000 bit message
      from A to B if message switching is used.







   b. Suppose packet switching is used and no additional bits are
      required for headers. How long will it take to send the entire
      message if 4000 bit packets are used.






5. Suppose headers of length H bits are used in the packet switching
   scheme described above. Suppose packet size is P (where
   P now includes header+data bits).  Under this new scheme the
   time to send a complete packet is:

   a. 10000 / (P + H)               b. 10000 / (P - H)

   c. 10000 * P                     d. P / 10000

6. Under the new scheme the total number of packets that must
   now be transmitted is:

   a. 200,000 * P                   b. 200,000 / P

   c. 200,000 / (P + H)             d. 200,000 / (P - H)

7. Suppose the value "t" represents the ONE WAY signal propogation
   delay between two stations on an ethernet and that the two stations
   transmit and cause a collision.  Suppose station 1 began transmitting
   first and station 2 began transmitting second.  Hint: the correct
   answers can be drawn (w/ replacement} from the following "urn":

               {0  t/2  2t 8t}
                \  t/4  4t  /
                 \____t____/

   a. What is the shortest possible amount of time after station 1
      starts transmitting that station 1 can hear the collision?


   b. What is the longest possible amount of time after station 2
      starts transmitting that station 2 can hear the collision?



   c. What is the shortest possible amount of time after station 2
      starts transmitting that station 1 can hear the collision.



7. In a dual persistent protocol a station transmits with prob p
   when it initially sense a channel idle and with prob q when
   it has to wait for a busy channel to become idle.  The proper
   relationship between p and q is:

   a. p > q                            b. p < q

   c. p = q                            d. q = 1 and q < p

8. Measurements of an infinite user slotted aloha channel show that in
   60% of the slots there is either a successful transmission or there
   is a collision.

   a. What is the total load (mean number of transmission attempts per
      packet time) = G.






   b. What is the throughput (S).





   c. Is the current load below or above the load required to
      obtain maximum throughput.




                      Computer Science 825
                         Quiz 3              Name _______________________

1. The main reason that an ethernet channel can support more packets /
   packet time throughput than a satellite based aloha system is that:

   a. The signal travels faster thru  b. All stations hear every ethernet
      an ethernet cable than thru        transmission but only the dest
      space.                             station hears an aloha transmission

   c. The signal propogation delay    d. Only one station at a time is
      is far shorter in an ethernet      allowed to transmit in an aloha
      than in a satellite net.           network.

2. The main function of the CD portion of a CSMA-CD protocol is to:

   a. Reduce the probability that     b. Reduce amount of wasted time
      a collision will occur.            when a collision occurs.

   c. Ensure that no collisions       d. Both a and b.
      occur at all.

3. The objective of the CS part of the CSMA-CD  protocol is to:

   a. Reduce the amount of time        b. Reduce the number of
      caused by collisions that           collisions that occur
      do occur

   c. Reduce the amount of idle        d. All of the above.
      time in which all stations
      are silent

4. If K stations share a CSMA bus and the probability that any station
   will transmit on a given contention slot is "p", then the probability
   that a successful transmission will take place in a slot is:

   a. p                            b. k * p * (1 - p) ^ (k - 1)

   c.  k * p * (1 - k) ^ (p - 1)   d. None of the above.

5. The probability of a successful Tx occuring during a slot is maximized
   if p =

   a. k                            b. 1/e

   c. 1/k                          d. None of the above

6. If the probability computed above is denoted A, then the probability
   that a contention interval will last exactly j slots is:

   a. A ^ (j - 1)  * (1 - A) ^ j    b. A / j

   c. j * (1 - A) ^ (j - 1)         d. None of the above.

7. Suppose that the average length of a contention interval on
   a CSMA bus is C and that the average time to transmit a packet is P.
   The efficiency of the channel is:

   a.  P / C                        b.  (P + C) / P

   c.  C / (P + C)                  d. None of the above

8. Each time an IEEE 802.3 Ethernet station suffers a collision
   (without having a successful transmission) the mean delay until
   its next attempt

   a. Increase by tau (the one       b. Increases by 2 * tau
      way prop delay).

   c. Doubles                        d. Increases by a factor of 2 ^ n
                                        where n is the number of
                                        collisions

9. Answer the following T or F. (Assume only the parameter indicated
   is being varied and all of the others remain fixed in each case.
   This question refers to a "traditional" shared bus ethernet.)

   ___ a. Increasing the average packet size will tend to make the efficiency
          of a CSMA CD LAN higher.

   ___ b. Increasing the physical length of a CSMA CD LAN will increase the length
          of the contention interval.

   ___ c. Decreasing the bit transmission rate from 10 Mbps to 1 Mbps
          increase the efficiency of a CSMA LAN


10. For the IEEE token bus match the control packets with the conditions
    underwhich they are used. (Some answers may or may not be used
    multiple times and some may or may not be used at all.)

   ____ a. A station recognizes a WHO_FOLLOWS   1. SOLICIT_SUCCESSOR_2
           packet specifying its predecessors
           address.                             2. SET_SUCCESSOR_2

   ____ b. A station wishes to leave the net.
                                                3. WHO_FOLLOWS

   ____ c. A station transmits the token twice  4. RESOLVE_CONTENTION
           without hearing its successor
           transmit a token or a packet.        5. CLAIM_TOKEN

   ____ d. A station wishes to invite a new     6. SOLICIT_SUCCESSOR
           station to enter the network.
                                                7. SET_SUCCESSOR

                                                8. WHO_KNOWS


11. Starvation of all priority classes except class 6 can occur on
   an IEEE 802.4 token bus: (N = # of stations).

   a. Never                          b. Any time all stations have a
                                        large backlog of class 6 traffic

   c. Only if THT >= TRT 4           d. Only if N * THT > TRT4


12. When a token ring interface is operating in receive mode bits
    flow:

   a. into one of the onboard        b. through the store and forward
      receive buffers                   buffer and on to the next station

   c. into the "bit-bucket"          d. Both a. and b.

                      Computer Science 825
                         Quiz 4              Name _______________________

1. In a token ring on which of the following should the "Monitor"
   bit NEVER be set.

   (Check all that apply)

   ___ a. A high priority data frame.

   ___ b. A high priority token

   ___ c. A 0 priority token.


2. What is the bandwidth in Hz of the range of frequencies that
   corresponds to all wavelengths between 1.2 x 10^(-6) m and
   1.4 x 10 ^ (-6) m.









3. Using a diagram, describe the "exposed station problem" that
   occurs in wireless LAN's







4. Suppose a 4 chip code is used in a CDMA system. Give a
   single codeword that is orthogonal to

   -1 +1 +1 -1




5. Simultaneous transmissions of data can occur simultaneously and
   non-destructively on which of the following LANs (Check ALL that apply)

   a. An ethernet using "shared       b. A switched ethernet.
      bus.

   c. A token bus                     d. A token ring

   e. An ATM LAN

6. In the hybrid MAC approaches used in satellite networks the typical
   objective is to act like:

   a. STDM at low loads and           b. Aloha at low loads
      Aloha at high loads                and STDM at high loads

   c. Aloha at very high and low
      loads and STDM at medium
      loads


7. In an 802.5 token ring system suppose the following events occur:

   Station D issues a priority 2 token
   Station A transmits to E using priority 2 token
   Station C makes a priority  3 reservation
   Station A generates a priority 3 token
   Station B transmits a priority 5 message to station C
   Station B transmits a priority 5 token
   Station C transmits a priority 5 message to station E
   Station C issues a priority 5 token. (and there is no more
   (high priority traffic that anyone has to send.)

   a. What is the priority of the next token issued (after (C,5))?



   b. Who issues it?




8. Why is it that the RTS/CTS protocol IS a good thing to do in 802.11
   wireless LANS but is not useful or good in 802.3 Ethernet LANs?







9. The RTS/CTS protocol is of primary benefit with:

   a. DCF                              b. PCF

   c. Equal benefit in both.


10. In what order do the following interframe slots appear in an 802.11
    LAN.

    ___ a. DIFS

    ___ b. SIFS

    ___ c. PIFS

11. The primary motivation for the use of fragmentation in 802.11
    but not in 802.3 (ethernet) is:

    a. Ethernet has a higher          b. 802.11 uses much larger
       bit rate                          packets

    c. 802.11 has a much higher
       bit error probability



                      Computer Science 825
                         Quiz 5              Name _______________________

1. In the standard bit stuffing the loss of an end flag (framing
   character) can be detected by:

   a. The appearance of some 0's       b. The appearance of some 1's where
      where there should only be 1's      there should only be 0's.

   c. The appearance of all 1's        d. The appearance of all 0's where
      where there should be a mix of      there should be a mix of 1's
      1's and 0's                         and 0's.

2. Suppose a 7  bit codeword with ODD parity is being used in a
   single bit hamming ECC.  Suppose the  following codeword is
   received.

      1  1  0  0  0  1  1
      --------------------
      1  2  3  4  5  6  7

   Which (if any) bit is in error?




3. a. Suppose a single bit Hamming ECC is to be performed on a
      511 bit codeword.  How many bits are in each of the
      parity checked groups (include the parity bit itself).



   b. How many bits does any pair of parity checked groups
      have in common with each other?


   c. How many distinct parity groups does bit 62 belong to.



   d. Suppose a two bit error occurs. Circle the correct description
      of the result.

      1. The fact that there is a two error can be detected, but the
         error can't be corrected.

      2. The two bit error will be undetected and the value that results
         from the correction process will be a legal code word but it
         will be the wrong one.

      3. The two bit error will be undetected and the corrected value will
         be either the wrong codeword or it might be the correct codeword.

      4. The two bit error will be undetected and the corrected value MAY
         be an illegal code word.

4. Suppose 2000 bit code words are to be transmitted and it is desired
   to use a Hamming code to correct  error bursts of up to 100 bits.
   How many of the 2000 bits must be used for ECC. (Hint: Fractional
   bit based strategies are not likely to be rewarded!)








5. Suppose a generator polynomial of G(x) = x^4 is used. G(x)
   can detect

   a. Some, but not all, of the errors      b. All errors involving the
      involving the last 4 bits of the         last 4 bits of the message
      message some but not all of the          but no errors that do not
      errors that don't involve the last       involve the last 4 bits.
      4 bits.

   c. All errors involving any of           d. All single bit errors but no more
      the last 4 bits of the message           than that.
      and some errors not involving
      any of the last 4 bits.

6. Suppose a 12 bit code word is used.  How many code words are
   at a Hamming distance of exactly 2 from a given code word.

   a. 12                        b. 144

   c. 132                       d. none of the above

7. Suppose a codeword contains "n" total bits. It is broken down
   as "m" msg  bits and "r" ECC bits.  Which of the following
   correctly characterizes the relationship between n, m, and r
   for single bit error correction to be done:

       r   m      n                           m      n
   a. 2 * 2   <= 2              b. (m + 1) * 2   <  2

                 r     m
   c. (n + 1) * 2  < 2          d. None of the above.


8. Suppose a BISYNCH message consists of the following byte pattern
   while it is "on the wire". Write down the data part of the message
   AFTER the receiver removes the "stuffed" bytes.

               |    this is the data part of the msg     |
   ------------------------------------------------------------------
   | DLE | STX | 'A' | DLE | DLE | 'B' | DLE | DLE | ETX | DLE | ETX |
   ------------------------------------------------------------------



9. Suppose A generator polynomial of x + 1 is used.  Answer the
   following T or F

    ___ a. Some but not all double bit errors in which the 2 error bits are
           adjacent in the message will be detected.

    ___ b. All errors consisting of 5 bits in error can be detected.


    ___ c. All double bit errors in which the 2 error bits are
           not adjacent in the message will be detected.

                      Computer Science 825
                         Quiz 6              Name _______________________










1. For the shift register shown above:

   a.  What generator polynomial is represented



   b.  What will be the NEW contents of the shift register
       after an input bit of "1" is processed.



   c.  Does the shift register represent the standard long
       division or pre-multiplying variety?



2. Suppose a premultiplying shift register is initialized with
   the first 4 bits of the message instead of all 0's.  Which
   statement best characterizes the situation

   a. It works fine either way     b. You will always get the wrong
                                      answer if you do it this way

   c. Whether or not you get the
      wrong answer depends on the
      number of 0 bits at the
      start of the message

3. In protocol 2, ACK's were used but no sequence numbers were used
   on frames or ACK's.  Which of the following problems could occur.

   a. Lost frames would go          b. Lost ACK's would result in
      undetected.                      lost frames

   c. Lost acks would result in     d. Lost frames would result in
      duplicate frames.                duplicate frames.

4. In protocol 3, frames's had sequence numbers but ACKS did not.
   Protocol 3 could fail in the presence of:

   a. ACK's that were lost          b. ACK's that were excessively
                                       delayed

   c. Frames that were lost.        d. Either a or b

5. When protocol 3 failed, the failure resulted in:

   a. The loss of 2 frames          b. The loss of 1 frame and
                                       the duplication of 1 frame.

   c. The duplication of 2          d. The loss of 1 frame
      frames.

6. Consider the following simplex connection.. Since the connection
   is simplex the sender side needs only nxtack and nxtsend state
   variables and the receiver side needs only nxtrecv. Assume that:
   the "ACK next frame expected" convention is used; the
   protocol uses sender and receiver window size = N;
   sequence numbers never wrap; and NO timeout and retransmits
   occur.

    nxtack  --------------------> nxtrecv
    nxtsend

   Answer the following T or F. At any instant in time:

   ____ a. nxtack must always be <= nxtrecv

   ____ b. nxtrecv may be < nxtack

   ____ c. nxtsend may be < nxtrcv

7. Suppose in a connection such as described in question 6 that
   after the connection has been idle for a while with
   nxtsend=nxtack=nxrecv=0 and the sender sends a burst of 5
   packets.  Which of the following values will reach "5" last

   a. nxtsend                       b. nxtrecv

   c. nxtack                        d. They will all reach 5 at
                                       the same instant


8. For each of the following combinations of propogation delay
   and error rate identify the most suitable variation of sliding
   window protocol. (The most suitable choice is the SIMPLEST
   one that doesn't incur a big performance penalty.)

   ___ a. No errors but packet time   1. Stop and Wait
          << propagation delay
   ___ b. No errors but packet time   2. Receiver buffering w/ out of
          >> propagation delay.          order retransmission
   ___ c. High errors and packet time
          << propagation delay        3. Receiver buffering w/ go back
                                         N sender

                                      4. Go back N.

9. For a sliding window protocol to function correctly it is
   necessary and sufficient that the timeout interval be greater than:

   a. 0                         b. the one-way propagation
                                   delay

   c. the two-way propagation   d. two times the two-way
      delay                        propagation delay.



                      Computer Science 825
                           Quiz 7          Name _______________________

1. Suppose that a satellite link has a ROUND TRIP propagation
   delay of 500 ms. Suppose bit transmission rate is 100,000 bits
   per second and packets are 1000 bits long.

   a. What will the efficiency of this channel be if stop and wait
      protocol is used.








   b. How large (in packets) must the SWS be in order to obtain 100%
      efficiency if the channel is guaranteed error free. (i.e. give
      me the MINIMUM SWS I can use).




   c. What is the MINIMUM size of the seq/ack number in bits that
      is required to support receiver buffering with out of order
      retransmission.


2. Show how a sliding window protocol that uses a 2 bit sequence
   number, a sender window of 3 and a receiver window of 2 can fail.








3. A buffer in the protocol discussed in class cycled though a number
   of queues.. Associate each transition with the process that
   caused it. (Some answers may be used more than once or not at all).

      ____ 1. Read pending to network      a.  Network layer process
              input.

      ____ 2. Network input to link        b.  Queuemsg process
              station output
                                           c.  Timeout process
      ____ 3. Link output to
              sender window.               d.  Writelink process

       ___ 4. Sender window to free        e.  Readlink process
              list

4. The sender window logic used three indexes: nxtsend; nxtqueue; and
   nxtack. We said these values always remained in a specific relative
   order. The order was

   a. send <= queue <= ack              b. queue <= ack <= send

   c. ack <= queue <= send              d. send <= ack <= queue

   e. None of the above

5. The value of the counting semaphore wpcount (that counted the
   number of packets waiting to be written is given by: (assume
   no sequence # wrap).

   a. queue - ack                       b. send - queue

   c. send - ack                        d. queue - send

6. Suppose the sequence number has 4 bits.  Then the value of the
   semaphore numslots is: (assume modular arithmetic is properly
   handled)

   a. 16 - (queue - ack)                b. 16 - (queue - send)

   c. 15 - (queue - send)               d. 15 - (queue - ack)

7. What were the two "fatal flaws" in the sample router protocol?
   (This is referring to MISSING CAPABILITIES -- not broken
   implementations).

   a -


   b -



8. Which of the following messages has suitable semantics for the
   unnumbered protocol. Hint: This question is NOT asking what
   specific frame types are in SDLC.  It IS asking what limitations
   are on the semantics of messages in protocols in which frames
   and acks carry no numbers.

   a. Increment current seq #      b. Set current seq # to 0.

   c. Both a and b.                d. Neither a nor b.

9. Suppose unnumbered frames were given sequence numbers and ACK numbers
   just like data frames and that the receiver of an out of sequence
   unnumbered frame would discard it just as it would an out of sequence
   data frame. Would this make the functions performed with unnum frames
   work:

    a. Much better and more         b. Work worse and less reliably.
       reliably.

    c. Make no appreciable difference.

10. The "failure" that the unnumbered protocol is susceptible to
    is:

    a. Undetected loss              b. Undetected duplication of
       of a frame.                     a frame.

    c. Reordering of frames         d. Both a. and b.
                     Computer Science 825
                           Quiz 8           Name _______________________

1. In the SSCOP, when <<NO>> packets have been lost, a STAT packet
   will contain three 4-byte fields.  Identify what they are in a way
   the indicates you understand their usage (i.e. abstract
   notation such as N(X) doesn't get the job done).

    a -


    b -


    c -


2. In the SSCOP, when the last packet to have been received
   successfully and in order is 57 and the the packets that
   have been received since then include 60 and 63
   The list part of the next "stat" packet should include:

   a. 58 60 61 63                     b. 58 61

   c. 58 60 63                        d. 58 61 62


3. A router in a typical "real world" network knows

    a. the entire path to the          b. the entire path from the
       destination of each packet         source of each packet it
       it processes                       processes

    c. both a. and b.                  d. only the next "hop" to
                                          which the packet should be
                                          forwarded.


4. The use of a RELIABLE network layer is more desirable

    a. with very unreliable links      b. with very reliable links
       than with very reliable links      than with very unreliable links

    c. has to relation to the reliability
       of the links.


5. The basic backward learning routing algorithm learns only
    for the better.  A mechanism that can be used to discover
    changes for the worse in the topology is to:

    a. Use duplexed tables and      b. Periodically use flooding.
       periodically initialize
       them to all dests unknown

    c. Add a time stamp to the      d. All of the above.
       packets.


Suppose two stations are connected by a path that is N hops long and
the probability of a successful transmission over each hop is p.

6. The expected number of total transmissions to get a packet from
    one end to the other if a reliable network layer is used is:
    (The reliable network repeats transmissions at each hop until it
    succeeds).

   a. N / p                          b. p / N

   c. 1 / p                          d. 1 / Np

7. The expected number of total transmissions to get a packet from
    one end to the other if an unreliable network layer is used is
    approximately:
    (The unreliable network layer just discards failed transmissions
    and depends on the transport layer to start over from the beginning
    if a packet doesn't succeed in making the whole trip)

   a. 1 / p^N                        b. N / (2 p ^ N)

   c. N ^ p / 2 ^ N                  d. N ^ p / p


8. Associate each of the following network layers with the
   class of service that it provides:

   ____ a. ATM network layer        1. Unreliable connectionless

                                    2. Reliable connectionless
   ____ b. SNA network layer
                                    3. Unreliable connection oriented

   ____ c. IP                       4. Reliable connection oriented


9. Of the 4 possible network service classes identified above which
   two are in the most widespread use today:

   a. 1 and 2                       b. 3 and 4

   b. 1 and 3                       d. 2 and 3

10. Which of the following is and advantage of the use of connection
    oriented network service over connectionless network service:

    a. more flexibility in routing    b. ease of providing QoS guarantees

    c. less disruptive  recovery      d. less state information to
       from failed routers               maintain in routers




                     Computer Science 825
                           Quiz 9           Name _______________________

1. Suppose the Bellman-Ford routing algorithm is being used and station
   D receives the following routing updates from neighbors A, C and E
   Suppose DA delay = 5, DC delay = 2 and DE delay = 3.
   Complete the routing table for D.,
      A  C  E      Cost VIA
   A  0  2  6          |
   ------------   ----------
   B  6 11  9          |
   ------------   ----------
   C  2  0  8          |
   ------------   ----------
   D  8  5  9          |
   ------------   ----------
   E  6  8  0          |
   ------------   ----------
   F  4  9 10          |
   ------------   ----------

2. Let N = number of nodes in a network and M = the average number
   of links / node.

   a. The minimum number of routing packets transmissions at each complete
      SPF routing exchange within the entire network is of order:

       1. M    2. N     3. N ^ 2    4. M ^ 2    5. N * M

   b. The minimum number of routing packets transmissions at each complete
      Bellman-Ford routing exchange within the entire network is of order:

       1. M    2. N     3. N ^ 2    4. M ^ 2    5. N * M

   c. The size of a routing info packet in Bellman-Ford is of order

      1. M      2. N      3. N ^ 2       4. N * M

   d. The size of a routing info packet in SPF is of order

      1. M      2. N      3. N ^ 2       4. N * M

3. Each routing update packet propagates

   a. Across the entire net in SPF    b. Only to adjacent neighbors in SPF
      and in Bellman-Ford                 and Bellman Ford

   c. Across entire net in SPF but    d. Across entire net in B-F but only
      only to adjacent neighbors in B-F   to adjacent neighbors is SPF

4. The routing algorithm used to transmit routing updates in an SPF
   network is typically:

   a. Static tables built by          b. Backward learning
      sysadmin

   c. Bellman-Ford                    d. Flooding

5. Routing loops can occur in SPF

   a. only when all nodes use the same   b. only when some nodes use a
      cost matrix                           different matrix than others

   c. in both cases a. and b.            d. Never, the SPF algorithm
                                            ALWAYS guarantees optimal routes

6. In a network that uses SPF suppose station B constructs the
   following cost matrix

       A   B   C   D   E

   A   0   2   -   1   6

   B   3   0   6   -   9

   C   -   6   0   7   2

   D   7   -  12   0   2

   E   4   9   2   4   0

   Draw the routing tree from node B to all destinations.
   Label the ARCs of the graph in the order in which they
   are made permanent in the SPF algorithm.

7. When it was originally used (in the late 1970's) for routing
   in the internet, the Bellman Ford's metric computation and
   routing exchange algorithms were:

   a. Average queue length +        b. Instantaneous queue length
      exchange at least once a         and exchange every 1 minute
      minute

   c. Average queue length +        d. Instantaneous queue length and
      exchange several times a         exchange several times per
      second                           second.

8. When it replaced Bellman-Ford (in the late 1970's) for routing
   in the internet, the OSPF metric computation and
   routing exchange algorithms were:

   a. Average queue length +        b. Instantaneous queue length
      exchange at least once a         and exchange every 1 minute
      minute

   c. Average queue length +        d. Instantaneous queue length and
      exchange several times a         exchange several times per
      second                           second.

9. In the modern Internet what is the essential difference between
   multi-homed and transit Autonomous systems:









10. The routed and gated routing daemons are primarily use for routing

    a. Within an AS                  b. between AS's

    c. Used for both purposes


                     Computer Science 825
                           Quiz A           Name _______________________

1. a. Suppose network addresses are 24 bits and flat routing tables
      are used. What is the maximum number of entries that may
      be required in a routing table.




   b. Suppose hierarchical routing is used and the addresses
      are partitioned as an 6 bit Area address; a 8  bit Network
      address and an 10 bit host addres. Now what is the maximum
      number of routing table entries.





2. Order the following broadcast algorithms according to the number
   of packet transmissions needed to complete a broadcast (1 = least
   transmissions; 3 = most).

   ______ a. Reverse Path Forwarding

   ______ b. Spanning tree.

   ______ c. Flooding


3. In the network shown suppose all hosts know
   the optimal route to A (hop count metric)
   and A initiates a reverse path forwarding
   broadcast. How many unnecessary transmissions
   will occur?



4. Suppose a wide-area multicast protocol is in effect and a router
   receives a message indicating that a host to which it was
   forwarding the multicast no longer wants to receive it.  That request
   should be forwarded upstream toward the source of the m'cast if:

   a. there are no more hosts downstream     b. there are additional hosts
      of the router who are receiving the       downstream who continue
      mcast.                                    to receive it.

   c. it must always be forwarded upstream   d. it should never be forwarded
                                                upstream

5. Preallocation of resources is a practical mechanism for congestion
   avoidance

   a. Only for reliable connnection      b. for either reliable or unreliable
      oriented network layers               connection oriented networks

   c. Only for connection-less network   d. Works fine for all of the above
      layers



6. The main factor that determines whether or not packet-discarding
   can be used as a congestion control mechanism in a network layer
   is:

   a. Whether the network layer     b. Whether the network layer is
      is connection oriented or        reliable or unreliable
      connection less.

   c. Both are equally important.   d. Neither is important at all.


7. Suppose that "leaky bucket" and "token bucket" admission control
   algorithms support identical maximal long-term sustained admission
   rates. Which of the following best characterizes their response to
   short high-rate arrival bursts:

   a. Leaky bucket allows short        b. Token bucket allows short
      term admission rate to exceed       term admission rate to exceed
      long term rates but token bucket    long term rates but leaky bucket
      does not.                           does not.

   c. Both allow short term admission  d. Neither allows short term rates
      rates to exceed long term rates.    to exceed  long term.


8. Suppose three traffic arrival streams have the same mean
   arrival rate.  Order the streams from 1 (smallest queue length)
   to 3 (largest queue length) according to the the following characteristics:

   ____ a. High variance ... no self-similarity

   ____ b. High variance ... high degree of self-similarity

   ____ c. Very low variance ... high degree of self-similarity.


9. "Bridging" is the interconnection of two networks at the:

    a. Physical layer             b. Datalink layer

    c. Network layer              d. Transport Layer


10. Aggregated on-off traffic sources have been shown to produce
    long range dependence as the number of sources and the length
    of the aggregation period becomes large if:

   a. the variance of the time        b. the mean time between packet
      between individual packet          transmissions is infinite
      transmissions is infinite

   c. the variance of the length of   d. the effect always occurs regardless
      the on/off periods is infinite     of the nature of the on-off
                                         processes

                     Computer Science 825
                           Quiz B           Name _______________________

1. The primary objective of the spanning tree algorithm in a transparent
   bridge system is to:

   a. Reduce the number of         b. Prevent indefinite packet looping.
      destination unknowns

   c. Ensure that the optimal      d. All of the above.
      route is taken.

2. Which routing algorithm is used by the source routing bridge
   in routing "discovery" packets to the destination.

   a. Spanning tree.              b. Flooding

   c. Backward learning.          d. Shortest path first.

3. Which routing algorithm is used by the spanning tree bridge
   if the location of the destination node is UNKNOWN?

   a. Spanning tree.              b. Flooding

   c. Backward learning.          d. Shortest past first.

4. Which routing algorithm does the spanning tree bridge employ
   in order to minimize the occurrences of destination unknowns.

   a. Spanning tree.              b. Flooding

   c. Backward learning.          d. Bellman-Ford.


5. With respect to the objective of Shortest Path Routing, which of
   the two bridging techniques we studied is superior.

   a. Spanning tree                    b. Source routing

   c. Both provide optimal paths

6. Consider the bridged network shown. Circles are bridges and lines
   LANs. Mark each interface on each bridge "R", "D", or "N" depending
   up whether it is the "Root Port", "Designated bridge port for the LAN",
   on "NOT in the spanning tree".


















7. A SNA VR manager receiving a packet with the Change Window Reply Indicator
   must:

   a. Stop sending immediately   b. Set the current pacing group size
                                    to the minimum pacing group size.

   c. Decrement the current      d. Increment the current pacing group
      pacing group size.            size.

8. A VR manager receiving a packet with the Reset Window Indicator
   must:

   a. Stop sending immediately   b. Set the current pacing group size
                                    to the minimum pacing group size.

   c. Decrement the current      d. None of the above.
      pacing group size.

9. When a VR manager receives a pacing response before the pacing
   count reaches 0 and it doesn't contain CRWI or RWI it

   a. Sets the pacing count to   b. Increments the current pacing
      the current pacing group      group size by 1.
      size.

   c. Adds the current pacing    d. Sets the pacing count to the
      group size to the pacing      maximum pacing group size.
      count.

10. What is the function of the "protocol" byte  found in the
   IP header?




11. Suppose the following is a diagram of an SNA network:

     B       E
   /   \   /   \
  A      D      G
   \   /   \   /
     C       F

    Answer the following T or F.

    ___ a. Nodes B and C can both have explicit routes with the
           identity (3, F).

    ___ b. For node B to have a functional explicit route with
           identity (3, G), node D must also have an explicit route
           with identity (3, G).

    ___ c. Nodes A and C can both have explicit routes with the
           identity (3, G) if  A's (3,G) passes through E and
           C's (3, G) passes through F.



                     Computer Science 825
                           Quiz C           Name _______________________

1. In IPV4 fragmentation and reassembly are performed as follows:

   a. Both can occur anywhere        b. Source host must fragment but
                                        reassembly is done just past
                                        the "bottleneck" router

   c. Fragmentation may occur        d. Fragmentation always occurs at
      anywhere but reassembly occurs    the source and reassembly at
      only at the destination.          the destination.

2. In the old class based IP address assignment architecture,
   which class of net does a node whose address is 190.215.17.139
   belong to.

   a. A                              b. B

   c. C                              d. D

3. IP datagrams can be up to 64K in size but the fragment offset
   field is only 13 bits.  How is it possible to know where a
   fragment is supposed to be placed if a datagram is larger than
   8KB?







4. Which was of the following was NOT a design objective of IPV6.

   a. Enlarge the internet address      b. Provide better support
      space.                               for mobile hosts.

   c. Provide additional fragmentation  d. Reduce computing time and table
      facilities to make it more ATM       size requirments in backbone
      compatible.                          routers

5. The type of service provided by IP and ATM is properly
   contrasted as follows:

   a. IP provides unreliable service   b. IP provides connection
      but ATM is reliable.                oriented service but ATM
                                          is connection less

   c. ATM provides unreliable service  b. ATM provides connection
      but IP is reliable.                 oriented service but IP
                                          is connection less

6. The number of distinct ATM addresses (not connection id's)  is:

   a. 1                                  b. 2^8

   c. 2^20                               d. 2^160

7. The full end-system ATM address is used in:

   a. SVC setup                          b. Routing of individual
                                            SVC cells

   c. PVC setup                          d. Routing of PVC cells

8. The number of address bytes that each ATM host "inherits"
    from the switch to which it is attached is:

    a. 6                                  b. 13

    c. 14                                 d. 19

9. The connection identifier (vpi, vci) for an SVC is assigned by

    a. the edge switch                    b. the originating host O/S

    c. the application program

10. The connection identifier (vpi, vci) for a specific SVC

    a. never changes                      b. MUST change at each hop

    c. MAY change at each hop

11. In an ATM network routing decisions:

  a. Must be made by the sysadmin        b. May be made dynamically
     before the network is activated.       at connection setup time

  c. May be made dynamically on a
     per cell basis as in IP.

12. Which of the following is an ATM network layer not permitted
    to do

    a. Discard cells                    b. Deliver cells with multiple
                                           bit errors

    c. Reorder cells                    d. All of the above

                      Computer Science 825
                         Quiz D           Name _______________________

Suppose a 3 way handshake is being used to establish a connection.
Let SYN-1 represent a packet that carries SYN and no ack.
Let SYN-2 represent a packet that carries both SYN and ACK that is
sent in response to a SYN.

1. A delayed duplicate SYN1 received in the ESTABLISHED state is:

   a. Responded to with SYN2     b. Always causes TCP to crash.

   c. Responded to with RESET.   d. Responded to with a data packet
                                    specifying current ACK and SEQ.


2. A delayed duplicate SYN1  received in the SYN-sent state is
   detected because:

   a. Both SEQ and ACK are       b. Undetected and causes the
      known to be wrong.            recipient to respond with
                                    a SYN-2

   c. The SEQ number is wrong.   d. The ACK number is wrong.


3. A delayed duplicate SYN1 received in the LISTEN state is:

   a. Responded to with RESET.   b. Responded to with a data packet
                                    specifying current ACK and SEQ.

   c. Responded to with SYN2     d. Always causes TCP to crash.



4. Suppose Tomlinson's clock proposal is used with a 18 bit sequence
   number and a clock that ticks 4096 times a second. Suppose maximum
   packet lifetime is 20 seconds.

   a. What is the MINIMUM amount of time in seconds that can elapse before
      sequence number resynchronization must occur.







   b. How often will synchronization be needed if packets are
      generated at 7/8 the maximum allowed rate.








   c. If the initial sequence number is 0 what will be the sequence
      number at the time resequencing takes place. (in question b).





5. Suppose a receiver in a stop and wait file transfer protocol uses
   an ack then write  policy and the sender uses a policy of
   retransmitting after a crash if and only if there was an unacknowledged
   packet outstanding at the time of the crash. Identify whether each of
   the following sequence of events will result in correct behavior (OK)
   a lost packet (LOST) or a duplicate (DUP).

         AWC               AC(W)             C(AW)



6. Suppose a TCP connection has SND.UNA = 2600 and SND.NXT = 3600 and
   a packet arrives with ACK = 3200 and WINDOW = 1000.

   a. How many more bytes may be transmitted before the sending TCP
      must stop sending because it runs out of usable space in the
      sender window.





   b. Suppose the sending application has an allocation of 8000
      bytes of transmit buffer space.  At what sequence number will
      the application be "put to sleep" if no additional acks
      are received.






7. Suppose an application has an allocation of  8,000 bytes of
   TCP receive buffer space.  The last byte that the application has
   consumed is 4000 and the present offered window is 7000. What is
   RCV.NXT?





8. Although the objectives of a reliable datalink protocol and an
   reliable transport protocol are basically the same, we identified
   several factors that make the implementation of the reliable
   transport over an unreliable connectionless network layer such as IP
   considerably more difficult.  Identify two of them:

   a -


   b -


